// Code generated by mockery v2.20.0. DO NOT EDIT.

package mockclients

import (
	context "context"

	mock "github.com/stretchr/testify/mock"

	types "gitlab.com/infor-cloud/martian-cloud/tharsis/tharsis-sdk-go/pkg/types"
)

// NamespaceMembership is an autogenerated mock type for the NamespaceMembership type
type NamespaceMembership struct {
	mock.Mock
}

// AddMembership provides a mock function with given fields: ctx, input
func (_m *NamespaceMembership) AddMembership(ctx context.Context, input *types.CreateNamespaceMembershipInput) (*types.NamespaceMembership, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.NamespaceMembership
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateNamespaceMembershipInput) (*types.NamespaceMembership, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateNamespaceMembershipInput) *types.NamespaceMembership); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.NamespaceMembership)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.CreateNamespaceMembershipInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteMembership provides a mock function with given fields: ctx, input
func (_m *NamespaceMembership) DeleteMembership(ctx context.Context, input *types.DeleteNamespaceMembershipInput) (*types.NamespaceMembership, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.NamespaceMembership
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.DeleteNamespaceMembershipInput) (*types.NamespaceMembership, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.DeleteNamespaceMembershipInput) *types.NamespaceMembership); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.NamespaceMembership)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.DeleteNamespaceMembershipInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetMemberships provides a mock function with given fields: ctx, input
func (_m *NamespaceMembership) GetMemberships(ctx context.Context, input *types.GetNamespaceMembershipsInput) ([]types.NamespaceMembership, error) {
	ret := _m.Called(ctx, input)

	var r0 []types.NamespaceMembership
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetNamespaceMembershipsInput) ([]types.NamespaceMembership, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetNamespaceMembershipsInput) []types.NamespaceMembership); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]types.NamespaceMembership)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetNamespaceMembershipsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateMembership provides a mock function with given fields: ctx, input
func (_m *NamespaceMembership) UpdateMembership(ctx context.Context, input *types.UpdateNamespaceMembershipInput) (*types.NamespaceMembership, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.NamespaceMembership
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.UpdateNamespaceMembershipInput) (*types.NamespaceMembership, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.UpdateNamespaceMembershipInput) *types.NamespaceMembership); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.NamespaceMembership)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.UpdateNamespaceMembershipInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

type mockConstructorTestingTNewNamespaceMembership interface {
	mock.TestingT
	Cleanup(func())
}

// NewNamespaceMembership creates a new instance of NamespaceMembership. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewNamespaceMembership(t mockConstructorTestingTNewNamespaceMembership) *NamespaceMembership {
	mock := &NamespaceMembership{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
